package geo

import (
	"context"

	"google.golang.org/grpc"
)

// DefaultClientStub provides default client stub as well as statically ensures stub is synchronized with external API
var DefaultClientStub GeoServiceClient = StubServiceClient{}

// StubServiceClient provides stub implementation of grpc client for testing purposes
type StubServiceClient struct {
}

// GetPois stub
func (stub StubServiceClient) GetPois(
	ctx context.Context,
	in *PoiRequest,
	opts ...grpc.CallOption,
) (*PoiResponse, error) {
	return nil, nil
}

// GetIsochrones stub
func (stub StubServiceClient) GetIsochrones(
	ctx context.Context,
	in *IsochroneRequest,
	opts ...grpc.CallOption,
) (*IsochroneResponse, error) {
	return nil, nil
}

// GetPoints stub
func (stub StubServiceClient) GetPoints(
	ctx context.Context,
	in *GetPointsRequest,
	opts ...grpc.CallOption,
) (*GetPointsResponse, error) {
	return nil, nil
}

// UpdateDB stub
func (stub StubServiceClient) UpdateDB(
	ctx context.Context,
	in *UpdateDBRequest,
	opts ...grpc.CallOption,
) (*UpdateDBResponse, error) {
	return nil, nil
}

// GetStations stub
func (stub StubServiceClient) GetStations(
	ctx context.Context,
	in *GetStationsRequest,
	opts ...grpc.CallOption,
) (*GetStationsResponse, error) {
	return nil, nil
}

// GetTowns stub
func (stub StubServiceClient) GetTowns(
	ctx context.Context,
	in *GetTownsRequest,
	opts ...grpc.CallOption,
) (*GetTownsResponse, error) {
	return nil, nil
}

// GetTownsInRadius stub
func (stub StubServiceClient) GetTownsInRadius(
	ctx context.Context,
	in *GetLocalityInRadiusRequest,
	opts ...grpc.CallOption,
) (*GetTownsResponse, error) {
	return nil, nil
}

// GetCountiesInRadius stub
func (stub StubServiceClient) GetCountiesInRadius(
	ctx context.Context,
	in *GetLocalityInRadiusRequest,
	opts ...grpc.CallOption,
) (*GetCountiesResponse, error) {
	return nil, nil
}

// GetRegionsInRadius stub
func (stub StubServiceClient) GetRegionsInRadius(
	ctx context.Context,
	in *GetLocalityInRadiusRequest,
	opts ...grpc.CallOption,
) (*GetRegionsResponse, error) {
	return nil, nil
}

// GetPlacesInRadius stub
func (stub StubServiceClient) GetPlacesInRadius(
	ctx context.Context,
	in *GetLocalityInRadiusRequest,
	opts ...grpc.CallOption,
) (*GetLocalityResponse, error) {
	return nil, nil
}

// GetPlacesByQuery stub
func (stub StubServiceClient) GetPlacesByQuery(
	ctx context.Context,
	in *GetLocalityRequest,
	opts ...grpc.CallOption,
) (*GetLocalityResponse, error) {
	return nil, nil
}

// GetSubTowns stub
func (stub StubServiceClient) GetSubTowns(
	ctx context.Context,
	in *GetSubTownsRequest,
	opts ...grpc.CallOption,
) (*GetTownsResponse, error) {
	return nil, nil
}

// GetCountiesInRegion stub
func (stub StubServiceClient) GetCountiesInRegion(
	ctx context.Context,
	in *GetCountiesInRegionRequest,
	opts ...grpc.CallOption,
) (*GetCountiesInRegionResponse, error) {
	return nil, nil
}

// GetCountiesSitemap stub
func (stub StubServiceClient) GetCountiesSitemap(
	ctx context.Context,
	in *GetCountiesSitemapRequest,
	opts ...grpc.CallOption,
) (*GetCountiesSitemapResponse, error) {
	return nil, nil
}

// GetTownsSitemap stub
func (stub StubServiceClient) GetTownsSitemap(
	ctx context.Context,
	in *GetTownsSitemapRequest,
	opts ...grpc.CallOption,
) (*GetTownsSitemapResponse, error) {
	return nil, nil
}

// GetRegionsSitemap stub
func (stub StubServiceClient) GetRegionsSitemap(
	ctx context.Context,
	in *GetRegionsSitemapRequest,
	opts ...grpc.CallOption,
) (*GetRegionsSitemapResponse, error) {
	return nil, nil
}

// GenerateSitemaps stub
func (stub StubServiceClient) GenerateSitemaps(
	ctx context.Context,
	in *GenerateSitemapsRequest,
	opts ...grpc.CallOption,
) (*GenerateSitemapsResponse, error) {
	return nil, nil
}

// ClearSitemapsCache stub
func (stub StubServiceClient) ClearSitemapsCache(
	ctx context.Context,
	in *ClearSitemapsCacheRequest,
	opts ...grpc.CallOption,
) (*ClearSitemapsCacheResponse, error) {
	return nil, nil
}

// SitemapDownload stub
func (stub StubServiceClient) SitemapDownload(
	ctx context.Context,
	in *SitemapDownloadRequest,
	opts ...grpc.CallOption,
) (GeoService_SitemapDownloadClient, error) {
	return nil, nil
}

// GetNearestTownsForLocationList stub
func (stub StubServiceClient) GetNearestTownsForLocationList(
	ctx context.Context,
	req *GetNearestTownsForLocationListRequest,
	opts ...grpc.CallOption,
) (*GetNearestTownsForLocationListResponse, error) {
	return nil, nil
}

// GetNearestPoints stub
func (stub StubServiceClient) GetNearestPoints(
	ctx context.Context,
	req *GetNearestPointsRequest,
	opts ...grpc.CallOption,
) (*GetNearestPointsResponse, error) {
	return nil, nil
}

// ListTimezones stub
func (stub StubServiceClient) ListTimezones(
	ctx context.Context,
	req *TimezonesRequest,
	opts ...grpc.CallOption,
) (*TimezonesResponse, error) {
	return nil, nil
}
