package model

import (
	"time"

	geo "gitlab.mashplace.com/mashplace/backend/geo/api"
)

// Location database model
type Location struct {
	ID          uint64        `db:"id"`
	Type        geo.PointType `db:"type"`
	Name        string        `db:"name"`
	Description string        `db:"description"`
	Lon         float64       `db:"lon"`
	Lat         float64       `db:"lat"`
	Source      string        `db:"source"`
	Importer    string        `db:"importer"`
	Time        time.Time     `db:"time"`
	Count       uint64        `db:"count"`
}

// LocationRelative database model
type LocationRelative struct {
	ID          uint64        `db:"id"`
	Type        geo.PointType `db:"type"`
	Name        string        `db:"name"`
	Description string        `db:"description"`
	Lon         float64       `db:"lon"`
	Lat         float64       `db:"lat"`
	Distance    float64       `db:"distance"`
}

// RadiusLonLat database model
type RadiusLonLat struct {
	Mod     uint64  `db:"mod"`
	Cluster uint64  `db:"cluster"`
	Lon     float64 `db:"lon"`
	Lat     float64 `db:"lat"`
	Radius  uint64  `db:"radius"`
}

// RadiusTypeLonLat database model
type RadiusTypeLonLat struct {
	Mod     uint64        `db:"mod"`
	Cluster uint64        `db:"cluster"`
	Lon     float64       `db:"lon"`
	Lat     float64       `db:"lat"`
	Radius  uint64        `db:"radius"`
	Type    geo.PointType `db:"type"`
	Limit   int32         `db:"limit"`
}

// AABBLonLat database model
type AABBLonLat struct {
	Mod     int     `db:"mod"`
	Cluster int     `db:"cluster"`
	AALon   float64 `db:"aalon"`
	AALat   float64 `db:"aalat"`
	BBLon   float64 `db:"bblon"`
	BBLat   float64 `db:"bblat"`
}

// LonLatWithLocationTypes ...
type LonLatWithLocationTypes struct {
	Lon        float64
	Lat        float64
	Radius     uint64
	PointTypes []geo.PointType
}
