package postgres

import (
	"context"

	"github.com/jmoiron/sqlx"
	"gitlab.mashplace.com/mashplace/backend/geo/internal/model"
)

type repositoryImplCountry struct {
	list *sqlx.Stmt
}

func prepareCountry(db *sqlx.DB) (stmt repositoryImplCountry, err error) {
	stmt.list, err = preparex(db, queryCountryList)
	if err != nil {
		return
	}

	return
}

const queryCountryList = `
select  distinct
  country
from towns
offset $1 limit $2
`

func (repo *repositoryImplCountry) CountryList(
	ctx context.Context,
	offset, limit int,
) (ms []*model.Country, err error) {
	if limit == 0 {
		limit = 1 << 30
	}

	err = repo.list.SelectContext(ctx, &ms, offset, limit)
	if err != nil {
		return nil, err
	}

	return
}
