
create table locations (
  id          bigserial primary key,
  type        integer not null,
  name        text not null,
  description text not null default '',
  pos         geography(POINT,4326) not null,
  mx          integer not null,
  my          integer not null,
  source      text not null default 'unknown',
  importer    text not null default 'mashroom-internal',
  time        timestamp not null default now(),
  unique(name, pos)
);

create index locations_pos_gix on locations using gist(pos);
create index locations_mx_btr on locations using btree(mx);
create index locations_my_btr on locations using btree(my);

create table towns (
  id          bigserial primary key,
  name        text not null,
  county text not null ,
  country text not null default '',
  area text not null default '',
  region text not null default '',
  postcode text not null default '',
  type text not null default '',
  pos         geography(POINT,4326) not null,
  mx          integer not null,
  my          integer not null,
  time        timestamp not null default now(),
  unique(name, pos)
);

create index towns_name on towns(name);
create index towns_pos_gix on towns using gist(pos);
create index towns_mx_btr on towns using btree(mx);
create index towns_my_btr on towns using btree(my);

create table imports (
  id       bigserial primary key,
  source   text not null default 'unknown',
  importer text not null default 'mashroom-internal',
  time     timestamp not null default now(),
  success  bigint not null default 0,
  failure  bigint not null default 0,
  message  text default ''
);
