
create table postcodes (
  id          bigserial primary key,
  postcode text not null ,
  name        text not null default '',
  county text not null default '',
  country text not null default '',
  region text not null default '',
  pos         geography(POINT,4326) not null,
  mx          integer not null,
  my          integer not null,
  time        timestamp not null default now(),
  unique(postcode, pos)
);

create index postcodes_code on postcodes(postcode);
create index postcodes_pos_gix on postcodes using gist(pos);
create index postcodes_mx_btr on postcodes using btree(mx);
create index postcodes_my_btr on postcodes using btree(my);

create table nearbypostcodes (
  id          bigserial primary key,
  postcode text not null ,
  nearby        text not null,
  time        timestamp not null default now(),
  unique(postcode, nearby)
);

create index nearbypostcodes_code on nearbypostcodes(postcode);
