package model

import "context"

// DefaultRepositoryStub provides noop stub instance for repository as well as statically ensuring interface compliance
var DefaultRepositoryStub Repository = StubRepository{}

// StubRepository provides noop repository implementation for use in tests
type StubRepository struct {
}

// Migrate stub
func (stub StubRepository) Migrate(ctx context.Context) error {
	return nil
}

// ImportSave stub
func (stub StubRepository) ImportSave(ctx context.Context, imp *Import) error {
	return nil
}

// ImportGetLastByImporterSource stub
func (stub StubRepository) ImportGetLastByImporterSource(
	ctx context.Context,
	importer, source string,
) (*Import, error) {
	return nil, nil
}

// LocationInsert stub
func (stub StubRepository) LocationInsert(ctx context.Context, location *Location) error {
	return nil
}

// LocationUpdate stub
func (stub StubRepository) LocationUpdate(ctx context.Context, location *Location) error {
	return nil
}

// LocationGetByID stub
func (stub StubRepository) LocationGetByID(ctx context.Context, id uint64) (*Location, error) {
	return nil, nil
}

// LocationListWithinRadius stub
func (stub StubRepository) LocationListWithinRadius(ctx context.Context, radius *RadiusLonLat) ([]*Location, error) {
	return nil, nil
}

// LocationListWithinBox stub
func (stub StubRepository) LocationListWithinBox(ctx context.Context, aabb *AABBLonLat) ([]*Location, error) {
	return nil, nil
}

// LocationListRelativeWithinRadius stub
func (stub StubRepository) LocationListRelativeWithinRadius(
	ctx context.Context,
	radius *RadiusTypeLonLat,
) ([]*LocationRelative, error) {
	return nil, nil
}

// PostcodeSave stub
func (stub StubRepository) PostcodeSave(ctx context.Context, postcode *Postcode) error {
	return nil
}

// PostcodeListByQuery stub
func (stub StubRepository) PostcodeListByQuery(ctx context.Context, query string, limit int) ([]*Postcode, error) {
	return nil, nil
}

// PostcodeListWithinRadius stub
func (stub StubRepository) PostcodeListWithinRadius(
	ctx context.Context,
	radius *RadiusLonLat,
	limit int,
) ([]*Postcode, error) {
	return nil, nil
}

// PostcodeNearbySave stub
func (stub StubRepository) PostcodeNearbySave(ctx context.Context, nearby *PostcodeNearby) error {
	return nil
}

// CountryList stub
func (stub StubRepository) CountryList(ctx context.Context, offset, limit int) ([]*Country, error) {
	return nil, nil
}

// RegionList stub
func (stub StubRepository) RegionList(ctx context.Context, offset, limit int) ([]*Region, error) {
	return nil, nil
}

// RegionListByQuery stub
func (stub StubRepository) RegionListByQuery(ctx context.Context, query string, limit int) ([]*Region, error) {
	return nil, nil
}

// RegionListByCountry stub
func (stub StubRepository) RegionListByCountry(ctx context.Context, country string) ([]*Region, error) {
	return nil, nil
}

// RegionListWithinRadius stub
func (stub StubRepository) RegionListWithinRadius(
	ctx context.Context,
	radius *RadiusLonLat,
	limit int,
) ([]*Region, error) {
	return nil, nil
}

// CountyList stub
func (stub StubRepository) CountyList(ctx context.Context, offset, limit int) ([]*County, error) {
	return nil, nil
}

// CountyListByQuery stub
func (stub StubRepository) CountyListByQuery(ctx context.Context, query string, limit int) ([]*County, error) {
	return nil, nil
}

// CountyListByCountryRegion stub
func (stub StubRepository) CountyListByCountryRegion(
	ctx context.Context,
	country, region string,
	limit int,
) ([]*County, error) {
	return nil, nil
}

// CountyListWithinRadius stub
func (stub StubRepository) CountyListWithinRadius(
	ctx context.Context,
	radius *RadiusLonLat,
	limit int,
) ([]*County, error) {
	return nil, nil
}

// TownInsert stub
func (stub StubRepository) TownInsert(ctx context.Context, town *Town) error {
	return nil
}

// TownUpdate stub
func (stub StubRepository) TownUpdate(ctx context.Context, town *Town) error {
	return nil
}

// TownGetByID stub
func (stub StubRepository) TownGetByID(ctx context.Context, id uint64) (*Town, error) {
	return nil, nil
}

// TownList stub
func (stub StubRepository) TownList(ctx context.Context, offset, limit int) ([]*Town, error) {
	return nil, nil
}

// TownListSub stub
func (stub StubRepository) TownListSub(ctx context.Context, id uint64, limit int) ([]*Town, error) {
	return nil, nil
}

// TownListByQuery stub
func (stub StubRepository) TownListByQuery(ctx context.Context, query string, limit int) ([]*Town, error) {
	return nil, nil
}

// TownListByCountry stub
func (stub StubRepository) TownListByCountry(ctx context.Context, country string) ([]*Town, error) {
	return nil, nil
}

// TownListByCountryRegionCounty stub
func (stub StubRepository) TownListByCountryRegionCounty(
	ctx context.Context,
	country, region, county string,
) ([]*Town, error) {
	return nil, nil
}

// TownListWithinRadius stub
func (stub StubRepository) TownListWithinRadius(
	ctx context.Context,
	radius *RadiusLonLat,
	limit int,
) ([]*Town, error) {
	return nil, nil
}

// GetNearestTownsForLocationList stub
func (stub StubRepository) GetNearestTownsForLocationList(
	ctx context.Context,
	radiusLonLatList []RadiusLonLat,
) (towns []*Town, err error) {
	return nil, nil
}

// GetNearestLocationList stub
func (stub StubRepository) GetNearestLocationList(
	ctx context.Context,
	lonLatList []LonLatWithLocationTypes,
) (ms [][]*LocationRelative, err error) {
	return nil, nil
}
