package model

import "time"

// Town database model
type Town struct {
	ID       uint64    `db:"id"`
	Name     string    `db:"name"`
	County   string    `db:"county"`
	Country  string    `db:"country"`
	Area     string    `db:"area"`
	Region   string    `db:"region"`
	Postcode string    `db:"postcode"`
	Type     string    `db:"type"`
	Lon      float64   `db:"lon"`
	Lat      float64   `db:"lat"`
	Time     time.Time `db:"time"`
	Order    int32     `db:"ord"`
}

// County database model
type County struct {
	ID      uint64  `db:"id"`
	Name    string  `db:"county"`
	Country string  `db:"country"`
	Region  string  `db:"region"`
	Lon     float64 `db:"lon"`
	Lat     float64 `db:"lat"`
}

// Country database model
type Country struct {
	Name string `db:"country"`
}

// Region database model
type Region struct {
	ID      uint64  `db:"id"`
	Name    string  `db:"region"`
	Country string  `db:"country"`
	Lon     float64 `db:"lon"`
	Lat     float64 `db:"lat"`
}
