// Package version stores built service version and health server init
package version

import (
	_ "embed" // embed data processing

	"gitlab.mashplace.com/mashplace/backend/common/generic/log"

	"gitlab.mashplace.com/mashplace/backend/common/api/health"
)

var (
	//go:embed version.txt
	version     string
	versionInfo = health.NewHealthVersion(version)
)

// NewHealthServer shows built service version and inits health server
func NewHealthServer() health.Server {
	log.Infof("%-32s:\t%v\n", "Version", versionInfo.ToString())

	return health.NewServer(versionInfo)
}
